from multiprocessing.pool import Pool
import matplotlib.pyplot as plt
from Calc_z_NormalDistri import calc_z
from mcmc import *

if __name__ == '__main__':
    nm_f_in = input('Input data file name = ')
    f_in = open(nm_f_in, 'r')

    nm_f_out = input('Output file name = ')
    f_out = open(nm_f_out, 'w')
    f_out.write('Data file = {}\n'.format(nm_f_in))

    Data_f = f_in.readlines()
    f_in.close()
 
    pos = 0
    while True:
        if len(Data_f[pos]) > 0:
            if Data_f[pos][0] == '/':
                pos += 1
                break
        pos += 1

    N_Vars = int(Data_f[pos])
    print('Number of variables = ', N_Vars)

    pos += 1
    while True:
        if len(Data_f[pos]) > 0:
            if Data_f[pos][0] == '/':
                pos += 1
                break
        pos += 1

    Ks = []
    strs = Data_f[pos].split()
    for s in strs:
        Ks.append(int(s))
    print('Ks = ', Ks)

    pos += 1
    while True:
        if len(Data_f[pos]) > 0:
            if Data_f[pos][0] == '/':
                pos += 1
                break
        pos += 1

    IDs = []
    strs = Data_f[pos].split()
    for i in range(N_Vars):
        IDs.append(strs[i + 1])
    print('IDs = ', IDs)
    

    pos += 1
    while True:
        if len(Data_f[pos]) > 0:
            if Data_f[pos][0] == '/':
                pos += 1
                break
        pos += 1

    Xs = []
    n = 0
    while True:
        strs = Data_f[pos].split()
        Xs.append([])
        for i in range(N_Vars):
            Xs[n].append(int(strs[i + 1]))
        n += 1
        pos += 1
        if Data_f[pos][0] == '/':
            break

    i = 0
    for v in Xs:
        if (i < 10) or (i > n - 10):
            print('{0}:  '.format(i), v)
        i += 1

    Rs = []
    for ix1 in range(N_Vars):
        Rs.append([])
        for ix2 in range(N_Vars):
            Rs[ix1].append(0.0)
            
    for ix1 in range(N_Vars):
        for ix2 in range(ix1, N_Vars):
            f_out.write('\n\nEstimatin for {0} and {1}\n'.format(IDs[ix1], IDs[ix2]))
            
            if ix1 == ix2:
                Rs[ix1][ix1] = 1.0
            else:
                Kx = Ks[ix1]
                Ky = Ks[ix2]
                V_IDx = IDs[ix1]
                V_IDy = IDs[ix2]
                X = []
                for i in range(n):
                    X.append([])
                    X[i].append(Xs[i][ix1])
                    X[i].append(Xs[i][ix2])

                print('\nKx = {0}   Ky = {1}'.format(Kx, Ky))
                print('V_IDx = {0}   V_IDy = {1}'.format(V_IDx, V_IDy))
                #   for i in range(n):
                #       print('{0}:  {1}  {2}'.format(i +1, X[i][0], X[i][1]))

                FreqX = []
                for i in range(Kx):
                    FreqX.append(0)
                FreqY = []
                for i in range(Ky):
                    FreqY.append(0)
                for i in range(n):
                    FreqX[X[i][0] - 1] += 1
                    FreqY[X[i][1] - 1] += 1

                print('\nFreqX = \n', FreqX)
                print('\nFreqY = \n', FreqY)

                CumFreqX = []
                CumPropX = []
                for k in range(Kx):
                    if k == 0:
                        CumFreqX.append(FreqX[0])
                        CumPropX.append(FreqX[0] / n)
                    else:
                        CumFreqX.append(FreqX[k] + CumFreqX[k - 1])
                        CumPropX.append(CumFreqX[k] / n)

                print('\nCumFreqX = ', CumFreqX)
                print('CumPropX = ', CumPropX)
                    
                CumFreqY = []
                CumPropY = []
                for k in range(Ky):
                    if k == 0:
                        CumFreqY.append(FreqY[0])
                        CumPropY.append(FreqY[0] / n)
                    else:
                        CumFreqY.append(FreqY[k] + CumFreqY[k - 1])
                        CumPropY.append(CumFreqY[k] / n)

                print('\nCumFreqY = ', CumFreqY)
                print('CumPropY = ', CumPropY)

                Cx = []
                for k in range(Kx - 1):
                    Cx.append(calc_z(CumPropX[k]))

                Cy = []
                for k in range(Ky - 1):
                    Cy.append(calc_z(CumPropY[k]))

                print('\nCx = ', Cx)
                print('\nCy = ', Cy)

                f_out.write('\nCx = {}\n'.format(Cx))
                f_out.write('\nCy = {}\n'.format(Cy))

                Nij = []
                for i in range(Kx):
                    Nij.append([])
                    for j in range(Ky):
                        Nij[i].append(0)
                for i in range(n):
                    Nij[X[i][0] - 1][X[i][1] - 1] += 1

                print('\nNij = \n', Nij)

                NSimu = 1000
                init_rho = 0.0
                gen_rho = 0.1

                params = {'Msg': 'state',
                            'jump': 1, 'Nij': Nij,  'Kx': Kx, 'Ky': Ky,
                          'Cx': Cx, 'Cy': Cy, 'NSimu': NSimu,
                          'init_rho': init_rho, 'gen_rho': gen_rho}

                step_adap = 0
                while True:
                    params['Msg'] = 'Adapting-{0} for Var-{1} and Var-{2}'.\
                                    format(step_adap, ix1, ix2)
                    rhos, n_acpt = mcmc_func( params )
                    sum = 0.0
                    for v in rhos:
                        sum += v
                    mean_rho = sum / len(rhos)
                    print('mean_rho = ', mean_rho)
                    params['init_rho'] = mean_rho

                    acpt_r = n_acpt / NSimu
                    ck = 0
                    v, ck = scale_sgm( acpt_r, ck )

                    print('acpt_r = ', acpt_r, '  v = ', v, '   ck = ', ck)

                    if ck > 0:
                        gen_rho *= v
                        params['gen_rho'] = gen_rho
                        print('gen_rho = {}\n'.format(gen_rho))
                        step_adap += 1
                    else:
                        break

                pool = Pool()
                NSimu = 2000
                params['NSimu'] = NSimu
                n_mcmc = 4
                ary_params = []
                for i in range(n_mcmc):
                    temp = params.copy()
                    temp['jump'] = i + 1
                    temp['Msg'] = 'Main_MCMC-{0} for Var-{1} and Var-{2}'.format(i, ix1, ix2)
                    ary_params.append(temp)

                print('The main MCMCs started.')
                results = pool.map(mcmc_func, ary_params)
                print('The main MCMCs ended.')
             
                ary_rhos = []
                for v1, v2 in results:
                    for u in v1:
                        ary_rhos.append(u)

                ary_rhos.sort()
                Q1 = ary_rhos[int(0.25 * len(ary_rhos))]
                Med = ary_rhos[int(0.5 * len(ary_rhos))]
                Q3 = ary_rhos[int(0.75 * len(ary_rhos))]
                print('\nQ1 = {0:.5}   Med = {1:.5}   Q3 = {2:.5}'.format(Q1, Med, Q3))
                f_out.write('\nQ1 = {0:.5}   Med = {1:.5}   Q3 = {2:.5}'.format(Q1, Med, Q3))
                Rs[ix1][ix2] = Rs[ix2][ix1] = Med
 
    f_out.write('\n\nMedian values of rhos...\n')
    for ix1 in range(N_Vars):
        for ix2 in range(N_Vars):
            f_out.write("{0:>10.3}".format(Rs[ix1][ix2]))
        f_out.write('\n')

    f_out.close()
    print(nm_f_out + ' was saved.')
    print()
